precision highp float;

varying vec2 t_coordinates;

uniform sampler2D t_data;
uniform sampler2D t2_data;
uniform sampler2D t_curve;
  
 void main()
 {
     mediump vec4 base = texture2D(t_data, t_coordinates);
     mediump vec4 overlay = texture2D(t2_data, t_coordinates);
     
     mediump float ra;
     if (base.r < 0.5) {
         ra = 2.0 * overlay.r * base.r + base.r * (1.0 - overlay.a);
     } else {
         ra = overlay.a - 2.0 * (1.0 - base.r) * (overlay.a - overlay.r) + base.r * (1.0 - overlay.a);
     }
     
     mediump float ga;
     if (base.g < 0.5) {
         ga = 2.0 * overlay.g * base.g + base.g * (1.0 - overlay.a);
     } else {
         ga = overlay.a - 2.0 * (1.0 - base.g) * (overlay.a - overlay.g) + base.g * (1.0 - overlay.a);
     }
     
     mediump float ba;
     if (base.b < 0.5) {
         ba = 2.0 * overlay.b * base.b + base.b * (1.0 - overlay.a);
     } else {
         ba = overlay.a - 2.0 * (1.0 - base.b) * (overlay.a - overlay.b) + base.b * (1.0 - overlay.a);
     }
     
  lowp vec4 textureColor = vec4(ra, ga, ba, 1.0);
  lowp float redCurveValue = texture2D(t_curve, vec2(textureColor.r, 0.0)).r;
  lowp float greenCurveValue = texture2D(t_curve, vec2(textureColor.g, 0.0)).g;
  lowp float blueCurveValue = texture2D(t_curve, vec2(textureColor.b, 0.0)).b;
     
  gl_FragColor = vec4(redCurveValue, greenCurveValue, blueCurveValue, textureColor.a);

 }