precision highp float;

#define BlendAdd(base, blend)           (base+blend)

varying vec2 layer1_coordinates;
varying vec2 base_coordinates;
uniform lowp sampler2D base_texture;
uniform lowp sampler2D layer1_texture;
uniform int blend_mode;
uniform float layer1_opacity;

void main(void) {
	lowp vec4 base_pixel = texture2D(base_texture, base_coordinates);
	lowp vec4 layer1_pixel = texture2D(layer1_texture, layer1_coordinates);

	lowp vec3 processing_pixel = layer1_pixel.rgb;
    lowp float calculated_opacity = layer1_pixel.a * layer1_opacity;
    lowp float alpha_factor = layer1_opacity;

    lowp vec4 processed_pixel = vec4(BlendAdd((1.0-calculated_opacity)*base_pixel.rgb, alpha_factor*processing_pixel.rgb),base_pixel.a*(1.0-calculated_opacity)+base_pixel.a*calculated_opacity);
    
    

	gl_FragColor = processed_pixel;
}