precision highp float;

varying highp vec2 t_coordinates;
 
 uniform sampler2D t_data;

 
 // Values from "Graphics Shaders: Theory and Practice" by Bailey and Cunningham
 const mediump vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);
//TODO: make a uniform
const lowp float saturation = 0.25;
const lowp float contrast = 1.2;
const lowp float brightness = 0.05;
 
 void main()
 {
    lowp vec4 textureColor = texture2D(t_data, t_coordinates);
    lowp float luminance = dot(textureColor.rgb, luminanceWeighting);
    lowp vec3 greyScaleColor = vec3(luminance);
    lowp vec4 saturatedColor = vec4(mix(greyScaleColor, textureColor.rgb, saturation), textureColor.w);
    
  lowp vec4 contrastedColor = vec4(((saturatedColor.rgb - vec3(0.5)) * contrast + vec3(0.5)), saturatedColor.w);
  
	gl_FragColor =  vec4((contrastedColor.rgb + vec3(brightness)), contrastedColor.w);

 }